﻿Imports System.IO

Public Class WriteEventForm

   Private output As StreamWriter

   ' determine validity of file type
   Private Function CheckValidity(ByVal name As String) As Boolean
      ' show error if user specified invalid file
      If name.ToLower().EndsWith(".txt") = False Then
         MessageBox.Show("File name must end with .txt", _
            "Invalid File Type", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
         Return False ' to indicate invalid file type
         ' change status of Buttons if file name is valid
      Else
         openFileButton.Enabled = False
         enterButton.Enabled = True
         closeFileButton.Enabled = True
         Return True ' to indicate text file specified
      End If
   End Function ' CheckValidity

   ' handles Open File... Button's Click event
   Private Sub openFileButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles openFileButton.Click

      ' display Open dialog
      Dim result As DialogResult = openFileDialog.ShowDialog()

      ' open specified file if user did not click Cancel Button
      If result <> Windows.Forms.DialogResult.Cancel Then
         ' get specified filename
         Dim fileName As String = openFileDialog.FileName

         ' validate file name
         If CheckValidity(fileName) = True Then
            ' enable user to append data to file via StreamWriter
            output = New StreamWriter(fileName, True)
         End If
      End If
   End Sub ' openFileButton_Click

   ' clear TextBoxes and reset NumericUpDown control
   Private Sub ClearUserInput()
      dayUpDown.Value = 1
      priceTextBox.Clear()
      eventTextBox.Clear()
      descriptionTextBox.Clear()
   End Sub ' ClearUserInput

   ' handles Enter Button's Click event
   Private Sub enterButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles enterButton.Click

      ' using StreamWriter to write data to file
      output.Write(dayUpDown.Value & ControlChars.Tab)
      output.Write(timeDateTimePicker.Text & ControlChars.Tab)
      output.Write(priceTextBox.Text & ControlChars.Tab)
      output.Write(eventTextBox.Text & ControlChars.Tab)
      output.WriteLine(descriptionTextBox.Text)
      ClearUserInput() ' prepare GUI for more user input
   End Sub ' enterButton_Click

   ' handles Close File Button's Click event
   Private Sub closeFileButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles closeFileButton.Click

      output.Close() ' close StreamWriter

      ' allow user to open another file
      openFileButton.Enabled = True
      enterButton.Enabled = False
      closeFileButton.Enabled = False
   End Sub ' closeFileButton_Click
End Class ' WriteEventForm

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************